ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.6 by root, Tue Dec 7 10:40:39 2010 UTC vs.
Revision 1.23 by root, Sat Dec 18 13:58:12 2010 UTC

2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10MKBUNDLE="$STATICPERL/mkbundle"
11
12# perl build variables 10# perl build variables
13PERL_PREFIX="$STATICPERL/perl" # where the perl gets installed 11MAKE=make
14PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice
13PERL_CC=cc
15PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 17
19ARCH="$(uname -m)" 18ARCH="$(uname -m)"
20 19
21case "$ARCH" in 20case "$ARCH" in
29 ;; 28 ;;
30esac 29esac
31 30
32# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
34# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 36
38# some configuration options for modules 37# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 38export PERL_MM_USE_DEFAULT=1
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
46 45
47# which extra modules you might want to install 46# which extra modules you might want to install
48EXTRA_MODULES="" 47EXTRA_MODULES=""
49 48
50# overridable functions 49# overridable functions
50preconfigure() { : ; }
51postconfigure() { : ; } 51postconfigure() { : ; }
52postbuild() { : ; } 52postbuild() { : ; }
53postinstall() { : ; } 53postinstall() { : ; }
54 54
55# now source user config, if any 55# now source user config, if any
56if [ "$STATICPERLRC" ]; then
57 . "$STATICPERLRC"
58else
56[ -r /etc/staticperlrc ] && . /etc/staticperlrc 59 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
57[ -r ~/.staticperlrc ] && . ~/.staticperlrc 60 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
58[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 61 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
62fi
59 63
60############################################################################# 64#############################################################################
61# support 65# support
66
67MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
68PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
69
70unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
71export LC_ALL=C # just to be on the safe side
62 72
63# set version in a way that Makefile.PL can extract 73# set version in a way that Makefile.PL can extract
64VERSION=VERSION; eval \ 74VERSION=VERSION; eval \
65$VERSION=0.1 75$VERSION=0.912
66 76
67BZ2=bz2 77BZ2=bz2
68BZIP2=bzip2 78BZIP2=bzip2
69 79
70fatal() { 80fatal() {
103############################################################################# 113#############################################################################
104# clean 114# clean
105 115
106distclean() { 116distclean() {
107 verblock <<EOF 117 verblock <<EOF
108deleting everything installed by this script 118 deleting everything installed by this script (rm -rf $STATICPERL)
109EOF 119EOF
110 120
111 rm -rf "$STATICPERL" 121 rm -rf "$STATICPERL"
112} 122}
113 123
114############################################################################# 124#############################################################################
115# download/configure/compile/install perl 125# download/configure/compile/install perl
116 126
117clean() { 127clean() {
118 cd "$STATICPERL/src/perl-$PERL_VERSION" 2>/dev/null || return 128 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
129}
119 130
120 rm -f staticstamp.configure 131realclean() {
121 make distclean >/dev/null 2>&1 132 rm -f "$PERL_PREFIX/staticstamp.postinstall"
133 rm -f "$PERL_PREFIX/staticstamp.install"
134 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
122} 135}
123 136
124fetch() { 137fetch() {
125 rcd "$STATICPERL" 138 rcd "$STATICPERL"
126 139
141 154
142 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 155 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
143 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 156 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
144 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 157 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
145 || fatal "$URL: unable to download" 158 || fatal "$URL: unable to download"
159 rm -f perl-$PERL_VERSION.tar.$BZ2
146 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 160 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
147 fi 161 fi
148 162
149 verblock <<EOF 163 verblock <<EOF
150unpacking perl 164unpacking perl
151EOF 165EOF
152 166
153 mkdir -p unpack 167 mkdir -p unpack
168 rm -rf unpack/perl-$PERL_VERSION
154 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xpC unpack \ 169 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \
155 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 170 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking"
171 chmod -R u+w unpack/perl-$PERL_VERSION
156 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 172 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
157 rmdir -p unpack 173 rmdir -p unpack
158 fi 174 fi
159} 175}
160 176
161# similar to GNU-sed -i or perl -pi 177# similar to GNU-sed -i or perl -pi
162sedreplace() { 178sedreplace() {
163 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 179 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
180 rm -f "$2"
164 mv "$2~" "$2" 181 mv "$2~" "$2"
182}
183
184configure_failure() {
185 cat <<EOF
186
187
188***
189*** Configure failed - see above for the exact error message(s).
190***
191*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
192*** flags are not supported by your compiler. Less often, this is because
193*** PERL_LIBS either contains a library not available on your system (such as
194*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
195***
196*** You can provide your own flags by creating a ~/.staticperlrc file with
197*** variable assignments. For example (these are the actual values used):
198***
199
200PERL_CC="$PERL_CC"
201PERL_CCFLAGS="$PERL_CCFLAGS"
202PERL_OPTIMIZE="$PERL_OPTIMIZE"
203PERL_LDFLAGS="$PERL_LDFLAGS"
204PERL_LIBS="$PERL_LIBS"
205
206EOF
207 exit 1
165} 208}
166 209
167configure() { 210configure() {
168 fetch 211 fetch
169 212
173 216
174 verblock <<EOF 217 verblock <<EOF
175configuring $STATICPERL/src/perl-$PERL_VERSION 218configuring $STATICPERL/src/perl-$PERL_VERSION
176EOF 219EOF
177 220
178 clean
179
180 rm -f "$PERL_PREFIX/staticstamp.install" 221 rm -f "$PERL_PREFIX/staticstamp.install"
181 222
223 "$MAKE" distclean >/dev/null 2>&1
224
225 sedreplace '/^#define SITELIB/d' config_h.SH
226
182 # I hate them 227 # I hate them for this
183 grep -q -- -fstack-protector Configure && \ 228 grep -q -- -fstack-protector Configure && \
184 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 229 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
230
231 preconfigure
185 232
186# trace configure \ 233# trace configure \
187 sh Configure -Duselargefiles \ 234 sh Configure -Duselargefiles \
188 -Uuse64bitint \ 235 -Uuse64bitint \
189 -Dusemymalloc=n \ 236 -Dusemymalloc=n \
190 -Uusedl \ 237 -Uusedl \
191 -Uusethreads \ 238 -Uusethreads \
192 -Uuseithreads \ 239 -Uuseithreads \
193 -Uusemultiplicity \ 240 -Uusemultiplicity \
194 -Duseperlio \
195 -Uusesfio \ 241 -Uusesfio \
196 -Uuseshrplib \ 242 -Uuseshrplib \
197 -Dcppflags="$PERL_CPPFLAGS" \ 243 -A ccflags=" $PERL_CCFLAGS" \
198 -Dccflags="-g2 -fno-strict-aliasing" \ 244 -Dcc="$PERL_CC" \
199 -Doptimize="$PERL_OPTIMIZE" \ 245 -Doptimize="$PERL_OPTIMIZE" \
200 -Dldflags="$PERL_LDFLAGS" \ 246 -Dldflags="$PERL_LDFLAGS" \
201 -Dlibs="$PERL_LIBS" \ 247 -Dlibs="$PERL_LIBS" \
202 -Dprefix="$PERL_PREFIX" \ 248 -Dprefix="$PERL_PREFIX" \
203 -Dbin="$PERL_PREFIX/bin" \ 249 -Dbin="$PERL_PREFIX/bin" \
204 -Dprivlib="$PERL_PREFIX/lib" \ 250 -Dprivlib="$PERL_PREFIX/lib" \
205 -Darchlib="$PERL_PREFIX/lib" \ 251 -Darchlib="$PERL_PREFIX/lib" \
206 -Uusevendorprefix \ 252 -Uusevendorprefix \
207 -Dsitelib="$PERL_PREFIX/lib" \ 253 -Dsitelib="$PERL_PREFIX/lib" \
208 -Dsitearch="$PERL_PREFIX/lib" \ 254 -Dsitearch="$PERL_PREFIX/lib" \
209 -Usitelibexp \
210 -Uman1dir \ 255 -Uman1dir \
211 -Uman3dir \ 256 -Uman3dir \
212 -Usiteman1dir \ 257 -Usiteman1dir \
213 -Usiteman3dir \ 258 -Usiteman3dir \
214 -Dpager=/usr/bin/less \ 259 -Dpager=/usr/bin/less \
215 -Demail="$EMAIL" \ 260 -Demail="$EMAIL" \
216 -Dcf_email="$EMAIL" \ 261 -Dcf_email="$EMAIL" \
217 -Dcf_by="$EMAIL" \ 262 -Dcf_by="$EMAIL" \
218 $PERL_CONFIGURE \ 263 $PERL_CONFIGURE \
264 -Duseperlio \
219 -dE || fatal "Configure failed" 265 -dE || configure_failure
220 266
221 sedreplace ' 267 sedreplace '
222 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 268 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
223 s/ *-fno-stack-protector */ /g 269 s/ *-fno-stack-protector */ /g
224 ' config.sh 270 ' config.sh
239building $STATICPERL/src/perl-$PERL_VERSION 285building $STATICPERL/src/perl-$PERL_VERSION
240EOF 286EOF
241 287
242 rm -f "$PERL_PREFIX/staticstamp.install" 288 rm -f "$PERL_PREFIX/staticstamp.install"
243 289
244 make || fatal "make: error while building perl" 290 "$MAKE" || fatal "make: error while building perl"
245 291
246 postbuild || fatal "postbuild hook failed" 292 postbuild || fatal "postbuild hook failed"
247} 293}
248 294
249install() { 295install() {
250 [ -e "$PERL_PREFIX/staticstamp.install" ] && return 296 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
251
252 build 297 build
253 298
254 verblock <<EOF 299 verblock <<EOF
255installing $STATICPERL/src/perl-$PERL_VERSION 300installing $STATICPERL/src/perl-$PERL_VERSION
256to $PERL_PREFIX 301to $PERL_PREFIX
257EOF 302EOF
258 303
259 rm -rf "$PERL_PREFIX" 304 ln -sf "perl/bin/" "$STATICPERL/bin"
260 305 ln -sf "perl/lib/" "$STATICPERL/lib"
306
307 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
308 rm -rf "$PERL_PREFIX" # by this rm -rf
309
261 make install || fatal "make install: error while installing" 310 "$MAKE" install || fatal "make install: error while installing"
262 311
263 rcd "$PERL_PREFIX" 312 rcd "$PERL_PREFIX"
264 313
265 # create a "make install" replacement for CPAN 314 # create a "make install" replacement for CPAN
266 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 315 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
267make install UNINST=1 316"$MAKE" || exit
317
268if find blib/arch/auto -type f | grep -q -v .exists; then 318if find blib/arch/auto -type f | grep -q -v .exists; then
269 echo Probably an XS module, rebuilding perl 319 echo Probably an XS module, rebuilding perl
270 make perl 320 if "$MAKE" perl; then
321 mv perl "$PERL_PREFIX"/bin/perl~ \
271 rm -f "$PERL_PREFIX"/bin/perl 322 && rm -f "$PERL_PREFIX"/bin/perl \
272 make -f Makefile.aperl inst_perl 323 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
273 make -f Makefile.aperl map_clean 324 "$MAKE" -f Makefile.aperl map_clean
325 else
326 "$MAKE" -f Makefile.aperl map_clean
327 exit 1
328 fi
274fi 329fi
330
331"$MAKE" install UNINST=1
275EOF 332EOF
276 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 333 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
277 334
278 # trick CPAN into avoiding ~/.cpan completely 335 # trick CPAN into avoiding ~/.cpan completely
279 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 336 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
280 337
281 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 338 "$PERL_PREFIX"/bin/perl -MCPAN -e '
282 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 339 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
283 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 340 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
284 CPAN::Shell->o (conf => q<init>); 341 CPAN::Shell->o (conf => q<init>);
285 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 342 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
286 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 343 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
287 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 344 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
288 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 345 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
289 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 346 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
290 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 347 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install");
291 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 348 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
292 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 349 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
293 CPAN::Shell->o (conf => q<commit>); 350 CPAN::Shell->o (conf => q<commit>);
294 ' || fatal "error while initialising CPAN" 351 ' || fatal "error while initialising CPAN"
295 352
353 touch "$PERL_PREFIX/staticstamp.install"
354 fi
355
356 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
296 NOCHECK_INSTALL=+ 357 NOCHECK_INSTALL=+
297 instcpan $STATICPERL_MODULES 358 instcpan $STATICPERL_MODULES
298 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 359 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
299 360
300 postinstall || fatal "postinstall hook failed" 361 postinstall || fatal "postinstall hook failed"
301 362
302 touch "$PERL_PREFIX/staticstamp.install" 363 touch "$PERL_PREFIX/staticstamp.postinstall"
364 fi
303} 365}
304 366
305############################################################################# 367#############################################################################
306# install a module from CPAN 368# install a module from CPAN
307 369
334 for mod in "$@"; do 396 for mod in "$@"; do
335 echo 397 echo
336 echo $mod 398 echo $mod
337 ( 399 (
338 rcd $mod 400 rcd $mod
339 make -f Makefile.aperl map_clean >/dev/null 2>&1 401 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
340 make distclean >/dev/null 2>&1 402 "$MAKE" distclean >/dev/null 2>&1
341 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 403 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
342 make || fatal "$mod: error building module" 404 "$MAKE" || fatal "$mod: error building module"
343 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 405 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
344 make distclean >/dev/null 2>&1 406 "$MAKE" distclean >/dev/null 2>&1
345 exit 0 407 exit 0
346 ) || exit $? 408 ) || exit $?
347 done 409 done
348} 410}
349 411
350############################################################################# 412#############################################################################
351# main 413# main
352 414
353podusage() { 415podusage() {
354 echo 416 echo
417
355 if [ -e "$PERL_PREFIX/bin/perl" ]; then 418 if [ -e "$PERL_PREFIX/bin/perl" ]; then
356 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 419 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
357 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 420 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
358 2>/dev/null && exit 421 2>/dev/null && exit
359 fi 422 fi
423
360 # try whatever perl we can find 424 # try whatever perl we can find
361 perl -MPod::Usage -e \ 425 perl -MPod::Usage -e \
362 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 426 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
363 2>/dev/null && exit 427 2>/dev/null && exit
364 428
365 fatal "displaying documentation requires a working perl - try '$0 install' first" 429 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
366} 430}
367 431
368usage() { 432usage() {
369 podusage 0 433 podusage 0
370} 434}
380} 444}
381 445
382bundle() { 446bundle() {
383 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 447 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
384 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 448 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
449 CACHE="$STATICPERL/cache"
450 mkdir -p "$CACHE"
385 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 451 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
386} 452}
387 453
388if [ $# -gt 0 ]; then 454if [ $# -gt 0 ]; then
389 while [ $# -gt 0 ]; do 455 while [ $# -gt 0 ]; do
390 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 456 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
391 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create" 457 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
392 458
393 command="${1#--}"; shift 459 command="${1#--}"; shift
394 case "$command" in 460 case "$command" in
461 version )
462 echo "staticperl version $VERSION"
463 ;;
395 fetch | configure | build | install | clean | distclean) 464 fetch | configure | build | install | clean | realclean | distclean)
396 verblock <<EOF
397$command
398EOF
399 ( "$command" ) 465 ( "$command" ) || exit
400 ;; 466 ;;
401 instsrc ) 467 instsrc )
402 ( instsrc "$@" ) 468 ( instsrc "$@" ) || exit
403 exit 469 exit
404 ;; 470 ;;
405 instcpan ) 471 instcpan )
406 ( instcpan "$@" ) 472 ( instcpan "$@" ) || exit
407 exit 473 exit
408 ;; 474 ;;
409 cpan ) 475 cpan )
410 ( install ) 476 ( install ) || exit
411 "$PERL_PREFIX/bin/cpan" "$@" 477 "$PERL_PREFIX/bin/cpan" "$@"
412 exit 478 exit
413 ;; 479 ;;
414 mkbundle ) 480 mkbundle )
415 ( install ) 481 ( install ) || exit
416 bundle "$@" 482 bundle "$@"
417 exit 483 exit
418 ;; 484 ;;
419 mkperl ) 485 mkperl )
420 ( install ) 486 ( install ) || exit
421 bundle --perl "$@" 487 bundle --perl "$@"
488 exit
489 ;;
490 mkapp )
491 ( install ) || exit
492 bundle --app "$@"
422 exit 493 exit
423 ;; 494 ;;
424 help ) 495 help )
425 podusage 2 496 podusage 2
426 ;; 497 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines